package nl.rubend.sudoku.internal.data

import nl.rubend.sudoku.internal.cloneCount

data class Grid(val rows: MutableList<Row>) {
    constructor(size: Int) : this(((1..size).map {
        Row((1..size).map {
                Cell((1..size).toMutableList() )
            }.toMutableList())
    }.toMutableList()))
    constructor(text: String): this(text.split('\n').size) {
        text.split('\n').forEachIndexed {rowIndex, row ->
            row.toCharArray().map { it.toString() }.forEachIndexed {cellIndex, cell ->
                if(arrayOf(" ","0").contains(cell)) return@forEachIndexed
                rows[rowIndex].cells[cellIndex].setValue(cell.toInt())
            }
        }
    }
    fun clone(): Grid {
        cloneCount++
        return Grid(rows.map {it.clone()}.toMutableList())
    }
    fun validate() {
        rows.forEach {it.validate()}
    }
    fun isSolved()=rows.none {!it.isSolved()}

    override fun toString()=rows.map {it.toString()}.joinToString("\n")
    fun toSheets()=rows.map {it.cells.map {it.singleValue()?:0}.joinToString(",")}.joinToString("\n")
}
