package nl.rubend.sudoku.internal.data

data class Row(val cells: MutableList<Cell>) {
    var id: Int = 0

    fun clone()= Row(cells.map {it.clone()}.toMutableList())

    fun validate() {
        cells.forEach {it.validate()}
    }

    override fun toString()=cells.map {it.singleValue()}.map {it?:" "}.joinToString("")
    fun isSolved()=cells.none{it.singleValue()==null}
}
