package nl.rubend.sudoku.internal.solver

import nl.rubend.sudoku.internal.solver.gridStrategies.*
import nl.rubend.sudoku.internal.solver.rowStrategies.*

fun gridStrategyFactory(strategy: String, settings: Map<String, String>): GridStrategy {
    if(strategy=="block") return BlockStrategy()
    if(strategy=="row") return EveryRowStrategy()
    if(strategy=="column") return ColumnStrategy()
    if(strategy=="extraBlock") return ExtraBlockStrategy()
    if(strategy=="diagonal") return DiagonalStrategy()
    if(strategy=="chaos") return ChaosStrategy(settings.get("grid")!!)
    throw RuntimeException("gridStrategy $strategy not found!")
}

fun rowStrategyFactory(strategy: String, settings: Map<String, String>): RowStrategy {
    if(strategy=="simple") return SimpleRemoveStrategy()
    if(strategy=="complicated") return ComplicatedRemoveStrategy(settings["max"]!!.toInt())
    if(strategy=="removeSingles") return RemoveSinglesStrategy()
    if(strategy=="oneMustBeStrategy") return OneMustBeStrategy()
    if(strategy=="ValidateStrategy") return ValidateStrategy()
    throw RuntimeException("rowStrategy $strategy not found!")
}
