package nl.rubend.sudoku.internal.solver.gridStrategies

import nl.rubend.sudoku.internal.data.Grid
import nl.rubend.sudoku.internal.data.Row

class BlockStrategy: GridStrategy {
    override fun getRows(grid: Grid): List<Row> {
        val rows = (1..grid.rows.size).map { Row(mutableListOf()) }.toMutableList()
        grid.rows.forEachIndexed {rowIndex, row ->
            row.cells.forEachIndexed {cellIndex, cell ->
                rows[rowIndex/3*3+cellIndex/3].cells.add(cell)
            }
        }
        return rows
    }

}
