package nl.rubend.sudoku.internal.solver.gridStrategies

import nl.rubend.sudoku.internal.data.Grid
import nl.rubend.sudoku.internal.data.Row

class ChaosStrategy(val rowConfig: List<List<Int>>): GridStrategy {
    constructor(rowConfig: String): this(Grid(rowConfig).rows.map { it.cells.map { it.singleValue()!! } })
    init {
        rowConfig.forEachIndexed {index, it -> if(it.size!=rowConfig.size) throw RuntimeException("chaos row index $index has invalid length ${it.size}, should be ${rowConfig.size}!")}
    }
    override fun getRows(grid: Grid): List<Row> {
        val rows=(1..grid.rows.size).map { Row(mutableListOf()) }
        rowConfig.forEachIndexed { rowIndex, row->
            row.forEachIndexed {cellIndex, cell ->
                rows[cell-1].cells.add(grid.rows[rowIndex].cells[cellIndex])
            }
        }
        rows.forEachIndexed {index, it -> if(it.cells.size!=rowConfig.size) throw RuntimeException("chaos row final index $index has invalid length ${it.cells.size}, should be ${rowConfig.size}!")}
        return rows
    }
}
