package nl.rubend.sudoku.internal.solver.gridStrategies

import nl.rubend.sudoku.internal.data.Grid
import nl.rubend.sudoku.internal.data.Row

class ColumnStrategy: GridStrategy {
    override fun getRows(grid: Grid): List<Row> {
        val rows = (1..grid.rows.size).map { Row(mutableListOf()) }.toMutableList()
        grid.rows.forEach { row->
            row.cells.forEachIndexed { cellIndex, cell ->
                rows[cellIndex].cells.add(cell)
            }
        }
        return rows
    }

}
