package nl.rubend.sudoku.internal.solver.gridStrategies

import nl.rubend.sudoku.internal.data.Grid
import nl.rubend.sudoku.internal.data.Row

class ExtraBlockStrategy: GridStrategy {
    override fun getRows(grid: Grid): List<Row> {
        val rows: List<Row> = (0..3).map { Row(mutableListOf()) }.toMutableList()
        grid.rows.forEachIndexed rowLoop@ {rowIndex, row->
            if(intArrayOf(0,4,8).contains(rowIndex)) return@rowLoop
            row.cells.forEachIndexed cellLoop@ {cellIndex, cell ->
                if(intArrayOf(0,4,8).contains(cellIndex)) return@cellLoop
                val isLeft=cellIndex<4
                val isTop=rowIndex<4
                val index = (if(isLeft) 0 else 1) + (if(isTop) 0 else 2)
                rows[index].cells.add(cell)
            }
        }
        return rows
    }

}
