package nl.rubend.sudoku.internal.solver.rowStrategies

import nl.rubend.sudoku.internal.data.Row

class ComplicatedRemoveStrategy(val max: Int) : RowStrategy {
    override fun doStrategy(row: Row) {
        for (i in 2..max) {
            row.cells
                .groupingBy { it.possibleValues }
                .eachCount()
                .filter { it.value == i }
                .map { it.key }
                .filter { it.size == i }
                .forEach { toRemove ->
                    row.cells.forEach cellLoop@ { cell ->
                        if (cell.possibleValues == toRemove) return@cellLoop
                        cell.possibleValues.removeIf { toRemove.contains(it) }
                    }
                }
        }
    }
}
