package nl.rubend.sudoku.internal.solver.rowStrategies

import nl.rubend.sudoku.internal.data.OneMustBe
import nl.rubend.sudoku.internal.data.Row

class OneMustBeStrategy: RowStrategy {
    override val iterations = 3
    override fun doStrategy(row: Row, iteration: Int) {
        if(iteration == 0) { //fill
            for(value in (1..row.cells.size)) {
                val cells = row.cells.filter {it.possibleValues.contains(value)}
                if(cells.size<=1) continue
                val oneMustBe = OneMustBe(
                    cells=cells,
                    value=value,
                )
                cells.forEach { it.oneMustBeList.add(oneMustBe) }
            }
            row.cells.forEach {
                it.oneMustBeList=it.oneMustBeList.distinct().toMutableList()
            }
        }
        if(iteration == 1) { //use
            val oneMustBeList = row.cells.flatMap {it.oneMustBeList.filter { row.cells.containsAll(it.cells) }}
            oneMustBeList.forEach { oneMustBe->
                row.cells.filter {!oneMustBe.cells.contains(it)}.forEach {
                    it.possibleValues.removeIf {it==oneMustBe.value}
                }
            }
        }
        if(iteration == 2) { //clear
            row.cells.forEach {it.oneMustBeList.clear()}
        }
    }
}
