package nl.rubend.sudoku.webserver.dto

import nl.rubend.sudoku.internal.data.Cell
import nl.rubend.sudoku.internal.data.Grid
import nl.rubend.sudoku.internal.data.Row

class GridDTO(
    val rows: List<List<CellDTO>>
) {
    constructor(): this(listOf())
    constructor(text: String): this(Grid(text))
    constructor(grid: Grid) : this(grid.rows.map { row ->
        row.cells.map { CellDTO(it) }.toMutableList()
    }.toMutableList())

    fun toGrid()=Grid(rows.map {
        Row(it.map {
            Cell(if(it.possibleValues.size > 0) it.possibleValues else (1..rows.size).toMutableList())
        }.toMutableList())
    }.toMutableList())
}
