package nl.rubend.sudoku

import nl.rubend.sudoku.internal.data.Grid
import nl.rubend.sudoku.internal.solver.MainStrategy
import nl.rubend.sudoku.internal.solver.gridStrategies.*
import nl.rubend.sudoku.internal.solver.rowStrategies.*
import org.junit.jupiter.api.Test

class ChaosTest {

    @Test
    fun chaosTest() {
        val grid = Grid("769000040\n" +
                "000000000\n" +
                "820000003\n" +
                "006000700\n" +
                "000000029\n" +
                "490100800\n" +
                "000000000\n" +
                "280000900\n" +
                "630800015")
        val rowStrategies = listOf(
            SimpleRemoveStrategy(),
            ComplicatedRemoveStrategy(2),
            RemoveSinglesStrategy(),
            OneMustBeStrategy(),
            ValidateStrategy(),
        )
        val gridStrategies = listOf(
            ChaosStrategy("111222223\n" +
                    "144222333\n" +
                    "114423333\n" +
                    "114555563\n" +
                    "144456667\n" +
                    "845555677\n" +
                    "888896677\n" +
                    "888999667\n" +
                    "899999777"),
            ColumnStrategy(),
            EveryRowStrategy(),
        )
        val outGrid = MainStrategy(gridStrategies, rowStrategies).run(grid)
        println(outGrid)
    }
}
