package nl.rubend.sudoku

import nl.rubend.sudoku.internal.Generator
import nl.rubend.sudoku.internal.cloneCount
import nl.rubend.sudoku.internal.solver.MainStrategy
import nl.rubend.sudoku.internal.solver.gridStrategies.*
import nl.rubend.sudoku.internal.solver.rowStrategies.*
import org.junit.jupiter.api.Test

class GenerateTest {

    @Test
    fun generateTest() {
        val validateGridStrategies: List<GridStrategy> = listOf(
            BlockStrategy(),
            ColumnStrategy(),
            EveryRowStrategy(),
//            DiagonalStrategy(),
//            ExtraBlockStrategy(),
        )

        val solveRowStrategies: List<RowStrategy> = listOf(
            OneMustBeStrategy(),
            RemoveSinglesStrategy(),
            ComplicatedRemoveStrategy(8),
            SimpleRemoveStrategy(),
        )
        val solveGridStrategies: List<GridStrategy> = listOf(
            BlockStrategy(),
            ColumnStrategy(),
            EveryRowStrategy(),
//            DiagonalStrategy(),
//            ExtraBlockStrategy(),
        )


        val solveStrategy = MainStrategy(solveGridStrategies, solveRowStrategies)

        val grid = Generator(
            validateGridStrategies=validateGridStrategies,
            solveStrategy=solveStrategy,
            size=9,
            seed=1234L
        ).run()
        println(grid)
        println()
        println(grid.toSheets())
        println("$cloneCount clones!")
    }
}
