package nl.rubend.sudoku

import nl.rubend.sudoku.internal.data.Grid
import nl.rubend.sudoku.internal.solver.MainStrategy
import nl.rubend.sudoku.internal.solver.gridStrategies.*
import nl.rubend.sudoku.internal.solver.rowStrategies.*
import org.junit.jupiter.api.Test

class SolveTest {

    @Test
    fun solveTest() {
        val grid = Grid("1 2      \n" +
                "    9 8 4\n" +
                "    7    \n" +
                "      3 5\n" +
                "   3     \n" +
                "         \n" +
                "     95  \n" +
                " 1   8   \n" +
                "         "
        )
        val rowStrategies = listOf(
            SimpleRemoveStrategy(),
//            ComplicatedRemoveStrategy(8),
            ValidateStrategy(),
            RemoveSinglesStrategy(),
            OneMustBeStrategy(),
        )
        val gridStrategies = listOf(
            BlockStrategy(),
            ColumnStrategy(),
            EveryRowStrategy(),
            DiagonalStrategy(),
            ExtraBlockStrategy(),
        )
        println(MainStrategy(gridStrategies, rowStrategies).run(grid)!!)
    }
}
