package nl.rubend.sudoku

import nl.rubend.sudoku.internal.Generator
import nl.rubend.sudoku.internal.cloneCount
import nl.rubend.sudoku.internal.solver.MainStrategy
import nl.rubend.sudoku.internal.solver.gridStrategies.*
import nl.rubend.sudoku.internal.solver.rowStrategies.*
import org.junit.jupiter.api.Test
import kotlin.system.measureTimeMillis

class SpeedTest {

    @Test
    fun generateSpeedTest() {
        val validateGridStrategies = listOf<GridStrategy>(
            BlockStrategy(),
            ColumnStrategy(),
            EveryRowStrategy(),
//            DiagonalStrategy(),
//            ExtraBlockStrategy(),
        )

        val solveRowStrategies = listOf(
            SimpleRemoveStrategy(),
            ComplicatedRemoveStrategy(2),
        )
        val solveGridStrategies = listOf<GridStrategy>(
            BlockStrategy(),
            ColumnStrategy(),
            EveryRowStrategy(),
//            DiagonalStrategy(),
//            ExtraBlockStrategy(),
        )


        val solveStrategy = MainStrategy(solveGridStrategies, solveRowStrategies)
        val generator = Generator(
            validateGridStrategies=validateGridStrategies,
            solveStrategy=solveStrategy,
            size=9,
        )
        val amount=50
        val time = measureTimeMillis {
            repeat(amount) {
                generator.run()
            }
        }
        println("$cloneCount clones to generate $amount sudoku's in $time millis. so about ${time/amount} ms/sudoku, with ${cloneCount/amount} clones/sudoku")
    }
}
